diff --git a/src/backend/parser/gram.y b/src/backend/parser/gram.y
index c5086846de..d7a885e78a 100644
--- a/src/backend/parser/gram.y
+++ b/src/backend/parser/gram.y
@@ -7742,13 +7757,13 @@ func_return:
  * is next best choice.
  */
 func_type:	Typename								{ $$ = $1; }
-			| type_function_name attrs '%' TYPE_P
+			| type_function_name attrs PERCENT TYPE_P
 				{
 					$$ = makeTypeNameFromNameList(lcons(makeString($1), $2));
 					$$->pct_type = true;
 					$$->location = @1;
 				}
-			| SETOF type_function_name attrs '%' TYPE_P
+			| SETOF type_function_name attrs PERCENT TYPE_P
 				{
 					$$ = makeTypeNameFromNameList(lcons(makeString($2), $3));
 					$$->pct_type = true;
@@ -7767,7 +7782,7 @@ func_arg_with_default:
 					$$ = $1;
 					$$->defexpr = $3;
 				}
-		| func_arg '=' a_expr
+		| func_arg EQUALS a_expr
 				{
 					$$ = $1;
 					$$->defexpr = $3;
@@ -7796,7 +7811,7 @@ aggr_arg:	func_arg
  * (ORDER BY aggr_arg,...)				- ordered-set agg with no direct args
  * (aggr_arg,... ORDER BY aggr_arg,...)	- ordered-set agg with direct args
  *
- * The zero-argument case is spelled with '*' for consistency with COUNT(*).
+ * The zero-argument case is spelled with STAR for consistency with COUNT(*).
  *
  * An additional restriction is that if the direct-args list ends in a
  * VARIADIC item, the ordered-args list must contain exactly one item that
@@ -7816,19 +7831,19 @@ aggr_arg:	func_arg
  * on existing aggregates, we can just apply extractArgTypes to the first
  * sublist.
  */
-aggr_args:	'(' '*' ')'
+aggr_args:	LPAREN STAR RPAREN
 				{
 					$$ = list_make2(NIL, makeInteger(-1));
 				}
-			| '(' aggr_args_list ')'
+			| LPAREN aggr_args_list RPAREN
 				{
 					$$ = list_make2($2, makeInteger(-1));
 				}
-			| '(' ORDER BY aggr_args_list ')'
+			| LPAREN ORDER BY aggr_args_list RPAREN
 				{
 					$$ = list_make2($4, makeInteger(0));
 				}
-			| '(' aggr_args_list ORDER BY aggr_args_list ')'
+			| LPAREN aggr_args_list ORDER BY aggr_args_list RPAREN
 				{
 					/* this is the only case requiring consistency checking */
 					$$ = makeOrderedSetArgs($2, $5, yyscanner);
@@ -7837,7 +7852,7 @@ aggr_args:	'(' '*' ')'
 
 aggr_args_list:
 			aggr_arg								{ $$ = list_make1($1); }
-			| aggr_args_list ',' aggr_arg			{ $$ = lappend($1, $3); }
+			| aggr_args_list COMMA aggr_arg			{ $$ = lappend($1, $3); }
 		;
 
 aggregate_with_argtypes:
@@ -7852,7 +7867,7 @@ aggregate_with_argtypes:
 
 aggregate_with_argtypes_list:
 			aggregate_with_argtypes					{ $$ = list_make1($1); }
-			| aggregate_with_argtypes_list ',' aggregate_with_argtypes
+			| aggregate_with_argtypes_list COMMA aggregate_with_argtypes
 													{ $$ = lappend($1, $3); }
 		;
 
@@ -7961,7 +7976,7 @@ createfunc_opt_item:
 		;
 
 func_as:	Sconst						{ $$ = list_make1(makeString($1)); }
-			| Sconst ',' Sconst
+			| Sconst COMMA Sconst
 				{
 					$$ = list_make2(makeString($1), makeString($3));
 				}
@@ -7969,7 +7984,7 @@ func_as:	Sconst						{ $$ = list_make1(makeString($1)); }
 
 transform_type_list:
 			FOR TYPE_P Typename { $$ = list_make1($3); }
-			| transform_type_list ',' FOR TYPE_P Typename { $$ = lappend($1, $5); }
+			| transform_type_list COMMA FOR TYPE_P Typename { $$ = lappend($1, $5); }
 		;
 
 opt_definition:
@@ -7993,7 +8008,7 @@ table_func_column_list:
 				{
 					$$ = list_make1($1);
 				}
-			| table_func_column_list ',' table_func_column
+			| table_func_column_list COMMA table_func_column
 				{
 					$$ = lappend($1, $3);
 				}
@@ -8169,7 +8184,7 @@ RemoveOperStmt:
 		;
 
 oper_argtypes:
-			'(' Typename ')'
+			LPAREN Typename RPAREN
 				{
 				   ereport(ERROR,
 						   (errcode(ERRCODE_SYNTAX_ERROR),
@@ -8177,24 +8192,24 @@ oper_argtypes:
 							errhint("Use NONE to denote the missing argument of a unary operator."),
 							parser_errposition(@3)));
 				}
-			| '(' Typename ',' Typename ')'
+			| LPAREN Typename COMMA Typename RPAREN
 					{ $$ = list_make2($2, $4); }
-			| '(' NONE ',' Typename ')'					/* left unary */
+			| LPAREN NONE COMMA Typename RPAREN					/* left unary */
 					{ $$ = list_make2(NULL, $4); }
-			| '(' Typename ',' NONE ')'					/* right unary */
+			| LPAREN Typename COMMA NONE RPAREN					/* right unary */
 					{ $$ = list_make2($2, NULL); }
 		;
 
 any_operator:
 			all_Op
 					{ $$ = list_make1(makeString($1)); }
-			| ColId '.' any_operator
+			| ColId DOT any_operator
 					{ $$ = lcons(makeString($1), $3); }
 		;
 
 operator_with_argtypes_list:
 			operator_with_argtypes					{ $$ = list_make1($1); }
-			| operator_with_argtypes_list ',' operator_with_argtypes
+			| operator_with_argtypes_list COMMA operator_with_argtypes
 													{ $$ = lappend($1, $3); }
 		;
 
@@ -8247,7 +8262,7 @@ dostmt_opt_item:
  *
  *****************************************************************************/
 
-CreateCastStmt: CREATE CAST '(' Typename AS Typename ')'
+CreateCastStmt: CREATE CAST LPAREN Typename AS Typename RPAREN
 					WITH FUNCTION function_with_argtypes cast_context
 				{
 					CreateCastStmt *n = makeNode(CreateCastStmt);
@@ -8258,7 +8273,7 @@ CreateCastStmt: CREATE CAST '(' Typename AS Typename ')'
 					n->inout = false;
 					$$ = (Node *)n;
 				}
-			| CREATE CAST '(' Typename AS Typename ')'
+			| CREATE CAST LPAREN Typename AS Typename RPAREN
 					WITHOUT FUNCTION cast_context
 				{
 					CreateCastStmt *n = makeNode(CreateCastStmt);
@@ -8269,7 +8284,7 @@ CreateCastStmt: CREATE CAST '(' Typename AS Typename ')'
 					n->inout = false;
 					$$ = (Node *)n;
 				}
-			| CREATE CAST '(' Typename AS Typename ')'
+			| CREATE CAST LPAREN Typename AS Typename RPAREN
 					WITH INOUT cast_context
 				{
 					CreateCastStmt *n = makeNode(CreateCastStmt);
@@ -8288,7 +8303,7 @@ cast_context:  AS IMPLICIT_P					{ $$ = COERCION_IMPLICIT; }
 		;
 
 
-DropCastStmt: DROP CAST opt_if_exists '(' Typename AS Typename ')' opt_drop_behavior
+DropCastStmt: DROP CAST opt_if_exists LPAREN Typename AS Typename RPAREN opt_drop_behavior
 				{
 					DropStmt *n = makeNode(DropStmt);
 					n->removeType = OBJECT_CAST;
@@ -8311,7 +8326,7 @@ opt_if_exists: IF_P EXISTS						{ $$ = true; }
  *
  *****************************************************************************/
 
-CreateTransformStmt: CREATE opt_or_replace TRANSFORM FOR Typename LANGUAGE name '(' transform_element_list ')'
+CreateTransformStmt: CREATE opt_or_replace TRANSFORM FOR Typename LANGUAGE name LPAREN transform_element_list RPAREN
 				{
 					CreateTransformStmt *n = makeNode(CreateTransformStmt);
 					n->replace = $2;
@@ -8323,11 +8338,11 @@ CreateTransformStmt: CREATE opt_or_replace TRANSFORM FOR Typename LANGUAGE name
 				}
 		;
 
-transform_element_list: FROM SQL_P WITH FUNCTION function_with_argtypes ',' TO SQL_P WITH FUNCTION function_with_argtypes
+transform_element_list: FROM SQL_P WITH FUNCTION function_with_argtypes COMMA TO SQL_P WITH FUNCTION function_with_argtypes
 				{
 					$$ = list_make2($5, $11);
 				}
-				| TO SQL_P WITH FUNCTION function_with_argtypes ',' FROM SQL_P WITH FUNCTION function_with_argtypes
+				| TO SQL_P WITH FUNCTION function_with_argtypes COMMA FROM SQL_P WITH FUNCTION function_with_argtypes
 				{
 					$$ = list_make2($11, $5);
 				}
@@ -8382,7 +8397,7 @@ ReindexStmt:
 					n->options = 0;
 					$$ = (Node *)n;
 				}
-			| REINDEX '(' reindex_option_list ')' reindex_target_type opt_concurrently qualified_name
+			| REINDEX LPAREN reindex_option_list RPAREN reindex_target_type opt_concurrently qualified_name
 				{
 					ReindexStmt *n = makeNode(ReindexStmt);
 					n->kind = $5;
@@ -8392,7 +8407,7 @@ ReindexStmt:
 					n->options = $3;
 					$$ = (Node *)n;
 				}
-			| REINDEX '(' reindex_option_list ')' reindex_target_multitable opt_concurrently name
+			| REINDEX LPAREN reindex_option_list RPAREN reindex_target_multitable opt_concurrently name
 				{
 					ReindexStmt *n = makeNode(ReindexStmt);
 					n->kind = $5;
@@ -8414,7 +8429,7 @@ reindex_target_multitable:
 		;
 reindex_option_list:
 			reindex_option_elem								{ $$ = $1; }
-			| reindex_option_list ',' reindex_option_elem	{ $$ = $1 | $3; }
+			| reindex_option_list COMMA reindex_option_elem	{ $$ = $1 | $3; }
 		;
 reindex_option_elem:
 			VERBOSE	{ $$ = REINDEXOPT_VERBOSE; }
@@ -9311,7 +9326,7 @@ AlterObjectSchemaStmt:
  *****************************************************************************/
 
 AlterOperatorStmt:
-			ALTER OPERATOR operator_with_argtypes SET '(' operator_def_list ')'
+			ALTER OPERATOR operator_with_argtypes SET LPAREN operator_def_list RPAREN
 				{
 					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);
 					n->opername = $3;
@@ -9321,12 +9336,12 @@ AlterOperatorStmt:
 		;
 
 operator_def_list:	operator_def_elem								{ $$ = list_make1($1); }
-			| operator_def_list ',' operator_def_elem				{ $$ = lappend($1, $3); }
+			| operator_def_list COMMA operator_def_elem				{ $$ = lappend($1, $3); }
 		;
 
-operator_def_elem: ColLabel '=' NONE
+operator_def_elem: ColLabel EQUALS NONE
 						{ $$ = makeDefElem($1, NULL, @1); }
-				   | ColLabel '=' operator_def_arg
+				   | ColLabel EQUALS operator_def_arg
 						{ $$ = makeDefElem($1, (Node *) $3, @1); }
 		;
 
@@ -9652,7 +9667,7 @@ publication_name_list:
 				{
 					$$ = list_make1($1);
 				}
-			| publication_name_list ',' publication_name_item
+			| publication_name_list COMMA publication_name_item
 				{
 					$$ = lappend($1, $3);
 				}
@@ -9776,12 +9791,12 @@ RuleStmt:	CREATE opt_or_replace RULE name AS
 RuleActionList:
 			NOTHING									{ $$ = NIL; }
 			| RuleActionStmt						{ $$ = list_make1($1); }
-			| '(' RuleActionMulti ')'				{ $$ = $2; }
+			| LPAREN RuleActionMulti RPAREN				{ $$ = $2; }
 		;
 
 /* the thrashing around here is to discard "empty" statements... */
 RuleActionMulti:
-			RuleActionMulti ';' RuleActionStmtOrEmpty
+			RuleActionMulti SEMICOLON RuleActionStmtOrEmpty
 				{ if ($3 != NULL)
 					$$ = lappend($1, $3);
 				  else
@@ -9839,7 +9854,7 @@ NotifyStmt: NOTIFY ColId notify_payload
 		;
 
 notify_payload:
-			',' Sconst							{ $$ = $2; }
+			COMMA Sconst							{ $$ = $2; }
 			| /*EMPTY*/							{ $$ = NULL; }
 		;
 
@@ -9858,7 +9873,7 @@ UnlistenStmt:
 					n->conditionname = $2;
 					$$ = (Node *)n;
 				}
-			| UNLISTEN '*'
+			| UNLISTEN STAR
 				{
 					UnlistenStmt *n = makeNode(UnlistenStmt);
 					n->conditionname = NULL;
@@ -10008,7 +10023,7 @@ transaction_mode_item:
 transaction_mode_list:
 			transaction_mode_item
 					{ $$ = list_make1($1); }
-			| transaction_mode_list ',' transaction_mode_item
+			| transaction_mode_list COMMA transaction_mode_item
 					{ $$ = lappend($1, $3); }
 			| transaction_mode_list transaction_mode_item
 					{ $$ = lappend($1, $2); }
@@ -10030,7 +10045,7 @@ opt_transaction_chain:
 /*****************************************************************************
  *
  *	QUERY:
- *		CREATE [ OR REPLACE ] [ TEMP ] VIEW <viewname> '('target-list ')'
+ *		CREATE [ OR REPLACE ] [ TEMP ] VIEW <viewname> LPARENtarget-list RPAREN
  *			AS <query> [ WITH [ CASCADED | LOCAL ] CHECK OPTION ]
  *
  *****************************************************************************/
@@ -10061,7 +10076,7 @@ ViewStmt: CREATE OptTemp VIEW qualified_name opt_column_list opt_reloptions
 					n->withCheckOption = $11;
 					$$ = (Node *) n;
 				}
-		| CREATE OptTemp RECURSIVE VIEW qualified_name '(' columnList ')' opt_reloptions
+		| CREATE OptTemp RECURSIVE VIEW qualified_name LPAREN columnList RPAREN opt_reloptions
 				AS SelectStmt opt_check_option
 				{
 					ViewStmt *n = makeNode(ViewStmt);
@@ -10079,7 +10094,7 @@ ViewStmt: CREATE OptTemp VIEW qualified_name opt_column_list opt_reloptions
 								 parser_errposition(@12)));
 					$$ = (Node *) n;
 				}
-		| CREATE OR REPLACE OptTemp RECURSIVE VIEW qualified_name '(' columnList ')' opt_reloptions
+		| CREATE OR REPLACE OptTemp RECURSIVE VIEW qualified_name LPAREN columnList RPAREN opt_reloptions
 				AS SelectStmt opt_check_option
 				{
 					ViewStmt *n = makeNode(ViewStmt);
@@ -10188,7 +10203,7 @@ createdb_opt_name:
  *	Though the equals sign doesn't match other WITH options, pg_dump uses
  *	equals for backward compatibility, and it doesn't seem worth removing it.
  */
-opt_equal:	'='										{}
+opt_equal:	EQUALS										{}
 			| /*EMPTY*/								{}
 		;
 
@@ -10258,7 +10273,7 @@ DropdbStmt: DROP DATABASE database_name
 					n->options = NULL;
 					$$ = (Node *)n;
 				}
-			| DROP DATABASE database_name opt_with '(' drop_option_list ')'
+			| DROP DATABASE database_name opt_with LPAREN drop_option_list RPAREN
 				{
 					DropdbStmt *n = makeNode(DropdbStmt);
 					n->dbname = $3;
@@ -10266,7 +10281,7 @@ DropdbStmt: DROP DATABASE database_name
 					n->options = $6;
 					$$ = (Node *)n;
 				}
-			| DROP DATABASE IF_P EXISTS database_name opt_with '(' drop_option_list ')'
+			| DROP DATABASE IF_P EXISTS database_name opt_with LPAREN drop_option_list RPAREN
 				{
 					DropdbStmt *n = makeNode(DropdbStmt);
 					n->dbname = $5;
@@ -10281,7 +10296,7 @@ drop_option_list:
 				{
 					$$ = list_make1((Node *) $1);
 				}
-			| drop_option_list ',' drop_option
+			| drop_option_list COMMA drop_option
 				{
 					$$ = lappend($1, (Node *) $3);
 				}
@@ -10614,7 +10629,7 @@ VacuumStmt: VACUUM opt_full opt_freeze opt_verbose opt_analyze opt_vacuum_relati
 					n->is_vacuumcmd = true;
 					$$ = (Node *)n;
 				}
-			| VACUUM '(' vac_analyze_option_list ')' opt_vacuum_relation_list
+			| VACUUM LPAREN vac_analyze_option_list RPAREN opt_vacuum_relation_list
 				{
 					VacuumStmt *n = makeNode(VacuumStmt);
 					n->options = $3;
@@ -10635,7 +10650,7 @@ AnalyzeStmt: analyze_keyword opt_verbose opt_vacuum_relation_list
 					n->is_vacuumcmd = false;
 					$$ = (Node *)n;
 				}
-			| analyze_keyword '(' vac_analyze_option_list ')' opt_vacuum_relation_list
+			| analyze_keyword LPAREN vac_analyze_option_list RPAREN opt_vacuum_relation_list
 				{
 					VacuumStmt *n = makeNode(VacuumStmt);
 					n->options = $3;
@@ -10650,7 +10665,7 @@ vac_analyze_option_list:
 				{
 					$$ = list_make1($1);
 				}
-			| vac_analyze_option_list ',' vac_analyze_option_elem
+			| vac_analyze_option_list COMMA vac_analyze_option_elem
 				{
 					$$ = lappend($1, $3);
 				}
@@ -10698,7 +10713,7 @@ opt_freeze: FREEZE									{ $$ = true; }
 		;
 
 opt_name_list:
-			'(' name_list ')'						{ $$ = $2; }
+			LPAREN name_list RPAREN						{ $$ = $2; }
 			| /*EMPTY*/								{ $$ = NIL; }
 		;
 
@@ -10712,7 +10727,7 @@ vacuum_relation:
 vacuum_relation_list:
 			vacuum_relation
 					{ $$ = list_make1($1); }
-			| vacuum_relation_list ',' vacuum_relation
+			| vacuum_relation_list COMMA vacuum_relation
 					{ $$ = lappend($1, $3); }
 		;
 
@@ -10755,7 +10770,7 @@ ExplainStmt:
 					n->options = list_make1(makeDefElem("verbose", NULL, @2));
 					$$ = (Node *) n;
 				}
-		| EXPLAIN '(' explain_option_list ')' ExplainableStmt
+		| EXPLAIN LPAREN explain_option_list RPAREN ExplainableStmt
 				{
 					ExplainStmt *n = makeNode(ExplainStmt);
 					n->query = $5;
@@ -10781,7 +10796,7 @@ explain_option_list:
 				{
 					$$ = list_make1($1);
 				}
-			| explain_option_list ',' explain_option_elem
+			| explain_option_list COMMA explain_option_elem
 				{
 					$$ = lappend($1, $3);
 				}
@@ -10822,7 +10837,7 @@ PrepareStmt: PREPARE name prep_type_clause AS PreparableStmt
 				}
 		;
 
-prep_type_clause: '(' type_list ')'			{ $$ = $2; }
+prep_type_clause: LPAREN type_list RPAREN			{ $$ = $2; }
 				| /* EMPTY */				{ $$ = NIL; }
 		;
 
@@ -10883,7 +10898,7 @@ ExecuteStmt: EXECUTE name execute_param_clause
 				}
 		;
 
-execute_param_clause: '(' expr_list ')'				{ $$ = $2; }
+execute_param_clause: LPAREN expr_list RPAREN				{ $$ = $2; }
 					| /* EMPTY */					{ $$ = NIL; }
 					;
 
@@ -10971,13 +10986,13 @@ insert_rest:
 					$$->override = $2;
 					$$->selectStmt = $4;
 				}
-			| '(' insert_column_list ')' SelectStmt
+			| LPAREN insert_column_list RPAREN SelectStmt
 				{
 					$$ = makeNode(InsertStmt);
 					$$->cols = $2;
 					$$->selectStmt = $4;
 				}
-			| '(' insert_column_list ')' OVERRIDING override_kind VALUE_P SelectStmt
+			| LPAREN insert_column_list RPAREN OVERRIDING override_kind VALUE_P SelectStmt
 				{
 					$$ = makeNode(InsertStmt);
 					$$->cols = $2;
@@ -11000,7 +11015,7 @@ override_kind:
 insert_column_list:
 			insert_column_item
 					{ $$ = list_make1($1); }
-			| insert_column_list ',' insert_column_item
+			| insert_column_list COMMA insert_column_item
 					{ $$ = lappend($1, $3); }
 		;
 
@@ -11042,7 +11057,7 @@ opt_on_conflict:
 		;
 
 opt_conf_expr:
-			'(' index_params ')' where_clause
+			LPAREN index_params RPAREN where_clause
 				{
 					$$ = makeNode(InferClause);
 					$$->indexElems = $2;
@@ -11166,16 +11181,16 @@ UpdateStmt: opt_with_clause UPDATE relation_expr_opt_alias
 
 set_clause_list:
 			set_clause							{ $$ = $1; }
-			| set_clause_list ',' set_clause	{ $$ = list_concat($1,$3); }
+			| set_clause_list COMMA set_clause	{ $$ = list_concat($1,$3); }
 		;
 
 set_clause:
-			set_target '=' a_expr
+			set_target EQUALS a_expr
 				{
 					$1->val = (Node *) $3;
 					$$ = list_make1($1);
 				}
-			| '(' set_target_list ')' '=' a_expr
+			| LPAREN set_target_list RPAREN EQUALS a_expr
 				{
 					int ncolumns = list_length($2);
 					int i = 1;
@@ -11211,7 +11226,7 @@ set_target:
 
 set_target_list:
 			set_target								{ $$ = list_make1($1); }
-			| set_target_list ',' set_target		{ $$ = lappend($1,$3); }
+			| set_target_list COMMA set_target		{ $$ = lappend($1,$3); }
 		;
 
 
@@ -11274,13 +11289,13 @@ opt_hold: /* EMPTY */						{ $$ = 0; }
  *
  * This approach is implemented by defining a nonterminal select_with_parens,
  * which represents a SELECT with at least one outer layer of parentheses,
- * and being careful to use select_with_parens, never '(' SelectStmt ')',
+ * and being careful to use select_with_parens, never LPAREN SelectStmt RPAREN,
  * in the expression grammar.  We will then have shift-reduce conflicts
- * which we can resolve in favor of always treating '(' <select> ')' as
+ * which we can resolve in favor of always treating LPAREN <select> RPAREN as
  * a select_with_parens.  To resolve the conflicts, the productions that
  * conflict with the select_with_parens productions are manually given
- * precedences lower than the precedence of ')', thereby ensuring that we
- * shift ')' (and then reduce to select_with_parens) rather than trying to
+ * precedences lower than the precedence of RPAREN, thereby ensuring that we
+ * shift RPAREN (and then reduce to select_with_parens) rather than trying to
  * reduce the inner <select> nonterminal to something else.  We use UMINUS
  * precedence for this, which is a fairly arbitrary choice.
  *
@@ -11297,8 +11312,8 @@ SelectStmt: select_no_parens			%prec UMINUS
 		;
 
 select_with_parens:
-			'(' select_no_parens ')'				{ $$ = $2; }
-			| '(' select_with_parens ')'			{ $$ = $2; }
+			LPAREN select_no_parens RPAREN				{ $$ = $2; }
+			| LPAREN select_with_parens RPAREN			{ $$ = $2; }
 		;
 
 /*
@@ -11378,8 +11393,8 @@ select_clause:
 
 /*
  * This rule parses SELECT statements that can appear within set operations,
- * including UNION, INTERSECT and EXCEPT.  '(' and ')' can be used to specify
- * the ordering of the set operations.	Without '(' and ')' we want the
+ * including UNION, INTERSECT and EXCEPT.  LPAREN and RPAREN can be used to specify
+ * the ordering of the set operations.	Without LPAREN and RPAREN we want the
  * operations to be ordered per the precedence specs at the head of this file.
  *
  * As with select_no_parens, simple_select cannot have outer parentheses,
@@ -11499,10 +11514,10 @@ with_clause:
 
 cte_list:
 		common_table_expr						{ $$ = list_make1($1); }
-		| cte_list ',' common_table_expr		{ $$ = lappend($1, $3); }
+		| cte_list COMMA common_table_expr		{ $$ = lappend($1, $3); }
 		;
 
-common_table_expr:  name opt_name_list AS opt_materialized '(' PreparableStmt ')'
+common_table_expr:  name opt_name_list AS opt_materialized LPAREN PreparableStmt RPAREN
 			{
 				CommonTableExpr *n = makeNode(CommonTableExpr);
 				n->ctename = $1;
@@ -11614,7 +11629,7 @@ all_or_distinct:
  */
 distinct_clause:
 			DISTINCT								{ $$ = list_make1(NIL); }
-			| DISTINCT ON '(' expr_list ')'			{ $$ = $4; }
+			| DISTINCT ON LPAREN expr_list RPAREN			{ $$ = $4; }
 		;
 
 opt_all_clause:
@@ -11633,7 +11648,7 @@ sort_clause:
 
 sortby_list:
 			sortby									{ $$ = list_make1($1); }
-			| sortby_list ',' sortby				{ $$ = lappend($1, $3); }
+			| sortby_list COMMA sortby				{ $$ = lappend($1, $3); }
 		;
 
 sortby:		a_expr USING qual_all_Op opt_nulls_order
@@ -11672,7 +11687,7 @@ opt_select_limit:
 limit_clause:
 			LIMIT select_limit_value
 				{ $$ = $2; }
-			| LIMIT select_limit_value ',' select_offset_value
+			| LIMIT select_limit_value COMMA select_offset_value
 				{
 					/* Disabled because it was too confusing, bjm 2002-02-18 */
 					ereport(ERROR,
@@ -11733,9 +11748,9 @@ select_offset_value:
  */
 select_fetch_first_value:
 			c_expr									{ $$ = $1; }
-			| '+' I_or_F_const
+			| PLUS I_or_F_const
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, $2, @1); }
-			| '-' I_or_F_const
+			| MINUS I_or_F_const
 				{ $$ = doNegate($2, @1); }
 		;
 
@@ -11781,7 +11796,7 @@ group_clause:
 
 group_by_list:
 			group_by_item							{ $$ = list_make1($1); }
-			| group_by_list ',' group_by_item		{ $$ = lappend($1,$3); }
+			| group_by_list COMMA group_by_item		{ $$ = lappend($1,$3); }
 		;
 
 group_by_item:
@@ -11793,34 +11808,34 @@ group_by_item:
 		;
 
 empty_grouping_set:
-			'(' ')'
+			LPAREN RPAREN
 				{
 					$$ = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, @1);
 				}
 		;
 
 /*
- * These hacks rely on setting precedence of CUBE and ROLLUP below that of '(',
+ * These hacks rely on setting precedence of CUBE and ROLLUP below that of LPAREN,
  * so that they shift in these rules rather than reducing the conflicting
  * unreserved_keyword rule.
  */
 
 rollup_clause:
-			ROLLUP '(' expr_list ')'
+			ROLLUP LPAREN expr_list RPAREN
 				{
 					$$ = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, $3, @1);
 				}
 		;
 
 cube_clause:
-			CUBE '(' expr_list ')'
+			CUBE LPAREN expr_list RPAREN
 				{
 					$$ = (Node *) makeGroupingSet(GROUPING_SET_CUBE, $3, @1);
 				}
 		;
 
 grouping_sets_clause:
-			GROUPING SETS '(' group_by_list ')'
+			GROUPING SETS LPAREN group_by_list RPAREN
 				{
 					$$ = (Node *) makeGroupingSet(GROUPING_SET_SETS, $4, @1);
 				}
@@ -11871,18 +11886,18 @@ locked_rels_list:
 
 
 /*
- * We should allow ROW '(' expr_list ')' too, but that seems to require
+ * We should allow ROW LPAREN expr_list RPAREN too, but that seems to require
  * making VALUES a fully reserved word, which will probably break more apps
  * than allowing the noise-word is worth.
  */
 values_clause:
-			VALUES '(' expr_list ')'
+			VALUES LPAREN expr_list RPAREN
 				{
 					SelectStmt *n = makeNode(SelectStmt);
 					n->valuesLists = list_make1($3);
 					$$ = (Node *) n;
 				}
-			| values_clause ',' '(' expr_list ')'
+			| values_clause COMMA LPAREN expr_list RPAREN
 				{
 					SelectStmt *n = (SelectStmt *) $1;
 					n->valuesLists = lappend(n->valuesLists, $4);
@@ -11906,7 +11921,7 @@ from_clause:
 
 from_list:
 			table_ref								{ $$ = list_make1($1); }
-			| from_list ',' table_ref				{ $$ = lappend($1, $3); }
+			| from_list COMMA table_ref				{ $$ = lappend($1, $3); }
 		;
 
 /*
@@ -12017,7 +12032,7 @@ table_ref:	relation_expr opt_alias_clause
 				{
 					$$ = (Node *) $1;
 				}
-			| '(' joined_table ')' alias_clause
+			| LPAREN joined_table RPAREN alias_clause
 				{
 					$2->alias = $4;
 					$$ = (Node *) $2;
@@ -12029,7 +12044,7 @@ table_ref:	relation_expr opt_alias_clause
  * It may seem silly to separate joined_table from table_ref, but there is
  * method in SQL's madness: if you don't do it this way you get reduce-
  * reduce conflicts, because it's not clear to the parser generator whether
- * to expect alias_clause after ')' or not.  For the same reason we must
+ * to expect alias_clause after RPAREN or not.  For the same reason we must
  * treat 'JOIN' and 'join_type JOIN' separately, rather than allowing
  * join_type to expand to empty; if we try it, the parser generator can't
  * figure out when to reduce an empty join_type right after table_ref.
@@ -12043,7 +12058,7 @@ table_ref:	relation_expr opt_alias_clause
  */
 
 joined_table:
-			'(' joined_table ')'
+			LPAREN joined_table RPAREN
 				{
 					$$ = $2;
 				}
@@ -12112,7 +12127,7 @@ joined_table:
 		;
 
 alias_clause:
-			AS ColId '(' name_list ')'
+			AS ColId LPAREN name_list RPAREN
 				{
 					$$ = makeNode(Alias);
 					$$->aliasname = $2;
@@ -12123,7 +12138,7 @@ alias_clause:
 					$$ = makeNode(Alias);
 					$$->aliasname = $2;
 				}
-			| ColId '(' name_list ')'
+			| ColId LPAREN name_list RPAREN
 				{
 					$$ = makeNode(Alias);
 					$$->aliasname = $1;
@@ -12149,17 +12164,17 @@ func_alias_clause:
 				{
 					$$ = list_make2($1, NIL);
 				}
-			| AS '(' TableFuncElementList ')'
+			| AS LPAREN TableFuncElementList RPAREN
 				{
 					$$ = list_make2(NULL, $3);
 				}
-			| AS ColId '(' TableFuncElementList ')'
+			| AS ColId LPAREN TableFuncElementList RPAREN
 				{
 					Alias *a = makeNode(Alias);
 					a->aliasname = $2;
 					$$ = list_make2(a, $4);
 				}
-			| ColId '(' TableFuncElementList ')'
+			| ColId LPAREN TableFuncElementList RPAREN
 				{
 					Alias *a = makeNode(Alias);
 					a->aliasname = $1;
@@ -12191,7 +12206,7 @@ join_outer: OUTER_P									{ $$ = NULL; }
  * We return USING as a List node, while an ON-expr will not be a List.
  */
 
-join_qual:	USING '(' name_list ')'					{ $$ = (Node *) $3; }
+join_qual:	USING LPAREN name_list RPAREN					{ $$ = (Node *) $3; }
 			| ON a_expr								{ $$ = $2; }
 		;
 
@@ -12204,7 +12219,7 @@ relation_expr:
 					$$->inh = true;
 					$$->alias = NULL;
 				}
-			| qualified_name '*'
+			| qualified_name STAR
 				{
 					/* inheritance query, explicitly */
 					$$ = $1;
@@ -12218,7 +12233,7 @@ relation_expr:
 					$$->inh = false;
 					$$->alias = NULL;
 				}
-			| ONLY '(' qualified_name ')'
+			| ONLY LPAREN qualified_name RPAREN
 				{
 					/* no inheritance, SQL99-style syntax */
 					$$ = $3;
@@ -12230,7 +12245,7 @@ relation_expr:
 
 relation_expr_list:
 			relation_expr							{ $$ = list_make1($1); }
-			| relation_expr_list ',' relation_expr	{ $$ = lappend($1, $3); }
+			| relation_expr_list COMMA relation_expr	{ $$ = lappend($1, $3); }
 		;
 
 
@@ -12267,7 +12282,7 @@ relation_expr_opt_alias: relation_expr					%prec UMINUS
  * TABLESAMPLE decoration in a FROM item
  */
 tablesample_clause:
-			TABLESAMPLE func_name '(' expr_list ')' opt_repeatable_clause
+			TABLESAMPLE func_name LPAREN expr_list RPAREN opt_repeatable_clause
 				{
 					RangeTableSample *n = makeNode(RangeTableSample);
 					/* n->relation will be filled in later */
@@ -12280,7 +12295,7 @@ tablesample_clause:
 		;
 
 opt_repeatable_clause:
-			REPEATABLE '(' a_expr ')'	{ $$ = (Node *) $3; }
+			REPEATABLE LPAREN a_expr RPAREN	{ $$ = (Node *) $3; }
 			| /*EMPTY*/					{ $$ = NULL; }
 		;
 
@@ -12306,7 +12321,7 @@ func_table: func_expr_windowless opt_ordinality
 					/* alias and coldeflist are set by table_ref production */
 					$$ = (Node *) n;
 				}
-			| ROWS FROM '(' rowsfrom_list ')' opt_ordinality
+			| ROWS FROM LPAREN rowsfrom_list RPAREN opt_ordinality
 				{
 					RangeFunction *n = makeNode(RangeFunction);
 					n->lateral = false;
@@ -12324,10 +12339,10 @@ rowsfrom_item: func_expr_windowless opt_col_def_list
 
 rowsfrom_list:
 			rowsfrom_item						{ $$ = list_make1($1); }
-			| rowsfrom_list ',' rowsfrom_item	{ $$ = lappend($1, $3); }
+			| rowsfrom_list COMMA rowsfrom_item	{ $$ = lappend($1, $3); }
 		;
 
-opt_col_def_list: AS '(' TableFuncElementList ')'	{ $$ = $3; }
+opt_col_def_list: AS LPAREN TableFuncElementList RPAREN	{ $$ = $3; }
 			| /*EMPTY*/								{ $$ = NIL; }
 		;
 
@@ -12366,7 +12381,7 @@ TableFuncElementList:
 				{
 					$$ = list_make1($1);
 				}
-			| TableFuncElementList ',' TableFuncElement
+			| TableFuncElementList COMMA TableFuncElement
 				{
 					$$ = lappend($1, $3);
 				}
@@ -12396,7 +12411,7 @@ TableFuncElement:	ColId Typename opt_collate_clause
  * XMLTABLE
  */
 xmltable:
-			XMLTABLE '(' c_expr xmlexists_argument COLUMNS xmltable_column_list ')'
+			XMLTABLE LPAREN c_expr xmlexists_argument COLUMNS xmltable_column_list RPAREN
 				{
 					RangeTableFunc *n = makeNode(RangeTableFunc);
 					n->rowexpr = $3;
@@ -12406,8 +12421,8 @@ xmltable:
 					n->location = @1;
 					$$ = (Node *)n;
 				}
-			| XMLTABLE '(' XMLNAMESPACES '(' xml_namespace_list ')' ','
-				c_expr xmlexists_argument COLUMNS xmltable_column_list ')'
+			| XMLTABLE LPAREN XMLNAMESPACES LPAREN xml_namespace_list RPAREN COMMA
+				c_expr xmlexists_argument COLUMNS xmltable_column_list RPAREN
 				{
 					RangeTableFunc *n = makeNode(RangeTableFunc);
 					n->rowexpr = $8;
@@ -12420,7 +12435,7 @@ xmltable:
 		;
 
 xmltable_column_list: xmltable_column_el					{ $$ = list_make1($1); }
-			| xmltable_column_list ',' xmltable_column_el	{ $$ = lappend($1, $3); }
+			| xmltable_column_list COMMA xmltable_column_el	{ $$ = lappend($1, $3); }
 		;
 
 xmltable_column_el:
@@ -12529,7 +12544,7 @@ xmltable_column_option_el:
 xml_namespace_list:
 			xml_namespace_el
 				{ $$ = list_make1($1); }
-			| xml_namespace_list ',' xml_namespace_el
+			| xml_namespace_list COMMA xml_namespace_el
 				{ $$ = lappend($1, $3); }
 		;
 
@@ -12574,12 +12589,12 @@ Typename:	SimpleTypename opt_array_bounds
 					$$->setof = true;
 				}
 			/* SQL standard syntax, currently only one-dimensional */
-			| SimpleTypename ARRAY '[' Iconst ']'
+			| SimpleTypename ARRAY LBRACKET Iconst RBRACKET
 				{
 					$$ = $1;
 					$$->arrayBounds = list_make1(makeInteger($4));
 				}
-			| SETOF SimpleTypename ARRAY '[' Iconst ']'
+			| SETOF SimpleTypename ARRAY LBRACKET Iconst RBRACKET
 				{
 					$$ = $2;
 					$$->arrayBounds = list_make1(makeInteger($5));
@@ -12599,9 +12614,9 @@ Typename:	SimpleTypename opt_array_bounds
 		;
 
 opt_array_bounds:
-			opt_array_bounds '[' ']'
+			opt_array_bounds LBRACKET RBRACKET
 					{  $$ = lappend($1, makeInteger(-1)); }
-			| opt_array_bounds '[' Iconst ']'
+			| opt_array_bounds LBRACKET Iconst RBRACKET
 					{  $$ = lappend($1, makeInteger($3)); }
 			| /*EMPTY*/
 					{  $$ = NIL; }
@@ -12618,7 +12633,7 @@ SimpleTypename:
 					$$ = $1;
 					$$->typmods = $2;
 				}
-			| ConstInterval '(' Iconst ')'
+			| ConstInterval LPAREN Iconst RPAREN
 				{
 					$$ = $1;
 					$$->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
@@ -12666,7 +12681,7 @@ GenericType:
 				}
 		;
 
-opt_type_modifiers: '(' expr_list ')'				{ $$ = $2; }
+opt_type_modifiers: LPAREN expr_list RPAREN				{ $$ = $2; }
 					| /* EMPTY */					{ $$ = NIL; }
 		;
 
@@ -12733,7 +12748,7 @@ Numeric:	INT_P
 				}
 		;
 
-opt_float:	'(' Iconst ')'
+opt_float:	LPAREN Iconst RPAREN
 				{
 					/*
 					 * Check FLOAT() precision limits assuming IEEE floating
@@ -12788,7 +12803,7 @@ ConstBit:	BitWithLength
 		;
 
 BitWithLength:
-			BIT opt_varying '(' expr_list ')'
+			BIT opt_varying LPAREN expr_list RPAREN
 				{
 					char *typname;
 
@@ -12848,7 +12863,7 @@ ConstCharacter:  CharacterWithLength
 				}
 		;
 
-CharacterWithLength:  character '(' Iconst ')'
+CharacterWithLength:  character LPAREN Iconst RPAREN
 				{
 					$$ = SystemTypeName($1);
 					$$->typmods = list_make1(makeIntConst($3, @3));
@@ -12889,7 +12904,7 @@ opt_varying:
  * SQL date/time types
  */
 ConstDatetime:
-			TIMESTAMP '(' Iconst ')' opt_timezone
+			TIMESTAMP LPAREN Iconst RPAREN opt_timezone
 				{
 					if ($5)
 						$$ = SystemTypeName("timestamptz");
